unit Bcrypt;
(** ================================= **)
(** Sourcesafe Unit Control Header **)
(** ================================= **)
(** $Archive: /DELPHI/1632/SHARED/encrypt.pas $ **)
(** $Revision: 2 $ **)
(** $Date: 31/05/96 15:14 $ **)
(** ================================= **)
(** Last Changed by                   **)
(** $Author: Gordon $ **)
(** $Modtime: 19/05/96 23:50 $ **)
(** ================================= **)
(** $NoKeywords: $ **)
(** ================================= **)

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs,DsgnIntf;
Type tmode = (MODE_ENCRYPT,MODE_DECRYPT);
Type tAllowed=Set of Char;

type
  TBCRYPT = class(TComponent)
  private
    { Private declarations }
  FAbout:	string;
  fkey:Word;
  foutput:String;
  fInput:String;
  fmode:tmode;
  falphamode:Boolean;
  Allowed:tAllowed;
  Function GetKey:Word;
  Procedure SetKey(w_Value:Word);
  Function Getfoutput:String;
  Function Getfinput:String;
  Procedure Setfoutput(s_Value:String);
  Procedure Setfinput(s_Value:String);
  function AlphaEncrypt(const S: String; Key: Word): String;
  function AlphaDecrypt(const S: String; Key: Word): String;

  protected
    { Protected declarations }
  function Prot_Encrypt(const S: String; Key: Word): String;
  function Prot_Decrypt(const S: String; Key: Word): String;
  function Prot_AlphaCrypt(const S: String; Key: Word): String;

  public
    { Public declarations }
  procedure ShowAbout;Virtual;
  Constructor Create(AOwner:TComponent);override;
  Procedure Loaded;override;
  Function Encrypt(s_String:String):String;
  Function Decrypt(s_String:String):String;

  published
    { Published declarations }
  property About: string read FAbout write FAbout stored False;
  Property Key:Word read GetKey write SetKey stored false;
  Property InString:String read getfinput write setfinput stored false;
  Property OutString:String read getfoutput write setfoutput stored False;
  Property Mode:tmode Read fmode write fmode stored False;
  Property AlphaMode:Boolean Read falphamode write falphamode stored false;
  end;

procedure Register;

(**) implementation (**)

(******************************************************************************)
(******************************************************************************)
type
  TAboutProperty = class(TPropertyEditor)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
    function GetValue:string; override;
  end;

procedure Register;
begin
  RegisterComponents('Maxim', [TBCRYPT]);
  {register the 'About' property editor}
  RegisterPropertyEditor(TypeInfo(String), TBCRYPT, 'About',
  	TAboutProperty);
end;
{########################################################################}
procedure TAboutProperty.Edit;
{call the 'About' dialog window when clicking on ... in the Object Inspector}
begin
  TBCRYPT(GetComponent(0)).ShowAbout;
end;
function TAboutProperty.GetAttributes: TPropertyAttributes;
{set up to display a string in the Object Inspector}
begin
  GetAttributes := [paDialog, paReadOnly];
end;
function TAboutProperty.GetValue: String;
{set string to appear in the Object Inspector}
begin
  GetValue := '(About)';
end;
procedure TBCRYPT.ShowAbout;
var
	msg: string;
const
  cr = chr(13);
begin
  msg := 'TBCRYPT (Improved TENCRYPT)' + cr;
  {$IFDEF WIN32}
  msg := msg + '(32 bit version)' + cr + cr;
  {$ELSE}
  msg := msg + '(16 bit version)' + cr + cr;
  {$ENDIF}
  msg := msg + 'Copyright 1996 Gordon Bamber' + cr;
  msg := msg + 'Email: gbamber@mistral.co.uk' + cr;
  msg := msg + 'Many thanks to Jonathan Farley' + cr;
  msg := msg + '(Author of TACRYPT)' + cr;
  msg := msg + 'All source available at Code Corner:' + cr;
  msg := msg + 'www.mistral.co.uk/gbamber/index.html' + cr + cr;

  MessageDlg(msg,mtInformation,[MBOK],0);
end;
{########################################################################}

(******************************************************************************)

Function TBCRYPT.GetKey;
begin
     Result:=fKey;
end;

(******************************************************************************)

Procedure TBCRYPT.SetKey(w_Value:Word);
begin
     if fkey <> w_Value then
      begin
        fkey:=w_Value;
        getfoutput;
      end;
end;

(******************************************************************************)

Function TBCRYPT.Prot_AlphaCrypt(const S: String; Key: Word): String;

(** This routine is common to the alphanumeric Enrypt and Decrypt **)

var
   I:Byte;
   T:String;
   Adder:Byte;
begin
  (** Make a variable copy **)
  T:=S;

  (** Work only with bit 7 on and bit 6 off **)
  T:=UpperCase(T);

  {$IFDEF WIN32}
  SetLength(Result,Length(S));
  {$ELSE}
  Result[0] := S[0];
  {$ENDIF}

  (** Use the key to obtain a consistent set of Random Numbers **)
  RandSeed:=LongInt(Key);
for I := 1 to Length(T) do begin
    (*** Return a number in range 0=>31 ***)
    Adder:=Byte(Trunc(Random * 31));

    (** Flip the lower 5 bits **)
    Result[I]:=char(byte(T[I]) xor Adder);

    (** Allow for bit 1 xor 1 producing a possible 64 code **)
    if not (Result[I] in allowed) then Result[I]:=T[I];

    (** Restore lowercase if in original string **)
    if (byte(S[I]) and 32)=32 then Result[I]:=Char(Byte(Result[I]) or 32);
 end;
end;

(******************************************************************************)

function TBCRYPT.AlphaEncrypt(const S: String; Key: Word): String;
begin
 Result:=Prot_AlphaCrypt(S,Key);
end;

(******************************************************************************)

function TBCRYPT.AlphaDecrypt(const S: String; Key: Word): String;
begin
 Result:=Prot_AlphaCrypt(S,Key);
end;

(******************************************************************************)

function TBCRYPT.Prot_Encrypt(const S: String; Key: Word): String;
const
  C1 = 52845;
  C2 = 22719;
var
  I: byte;
begin
  {$IFDEF WIN32}
  SetLength(Result,Length(S));
  {$ELSE}
  Result[0] := S[0];
  {$ENDIF}
  for I := 1 to Length(S) do begin
    Result[I] := char(byte(S[I]) xor (Key shr 8));
    Key := (byte(Result[I]) + Key) * C1 + C2;
  end;
end;

(******************************************************************************)

function TBCRYPT.Prot_Decrypt(const S: String; Key: Word): String;
const
  C1 = 52845;
  C2 = 22719;
var
  I: byte;
begin
  {$IFDEF WIN32}
  SetLength(Result,Length(S));
  {$ELSE}
  Result[0] := S[0];
  {$ENDIF}
  for I := 1 to Length(S) do begin
    Result[I] := char(byte(S[I]) xor (Key shr 8));
    Key := (byte(S[I]) + Key) * C1 + C2;
  end;
end;

(******************************************************************************)

Function TBCRYPT.Encrypt(s_String:String):String;
begin
  if falphamode then
    Result:=AlphaEncrypt(s_String,fKey)
  else Result:=Prot_Encrypt(s_String,fKey);

end;

(******************************************************************************)

Function TBCRYPT.Decrypt(s_String:String):String;
begin
  if falphamode then
    Result:=AlphaDecrypt(s_String,fKey)
  else Result:=Prot_Decrypt(s_String,fKey);
end;

(******************************************************************************)

Function TBCRYPT.Getfoutput:String;
begin
    if fmode=MODE_ENCRYPT then
        Result:=Encrypt(finput)
    else
        Result:=Decrypt(finput);

end;

(******************************************************************************)

Function TBCRYPT.Getfinput:String;
Begin
     Result:=finput;
end;

(******************************************************************************)

Procedure TBCRYPT.Setfoutput(s_Value:String);
begin
     if s_Value <> foutput then foutput:=Getfoutput;
end;

(******************************************************************************)

Procedure TBCRYPT.Setfinput(s_Value:String);
begin
     if s_value <> finput then
       begin
         finput:=s_Value;
         GetfOutPut;
       end;
end;

(******************************************************************************)

Procedure TBCRYPT.Loaded;
begin
     Inherited Loaded;
     fmode:=MODE_ENCRYPT;
     finput:='Code-Corner 123/456AB';
     fKey:=1234;
     falphamode:=True;
     Getfoutput;
end;

(******************************************************************************)

Constructor TBCRYPT.Create(AOwner:TComponent);
begin
     Inherited Create(AOwner);
     falphamode:=True;
     fmode:=MODE_ENCRYPT;
     finput:='Code-Corner 123/456AB';
     fKey:=1234;
     Allowed:=['A'..'Z'];
     Getfoutput;
end;

(******************************************************************************)

end.
